//---------------------------------------------------------------------------
// Copyright 1998 Andreas Huennebeck
//
// $Source: 
// $Id: 
//
// Description: implementation of class BPT (bipolar Transistor)
//
//---------------------------------------------------------------------------

static const char rcsid[] = "$Id: BPT.c,v 1.4 2001/10/05 23:44:26 ah Exp $ (c) 1998 Andreas Huennebeck";

// --- necessary includes ---

#include <AH/Config/Platform.h>
#include <AH/Etech/BPT.h>

USING_NAMESPACE(Ah)

BEGIN_NAMESPACE(Ah)

// --- class member implementation ---


// Sperrstrom fuer Silizium
const Current BPT::Ics(10e-12);



// get steilheit
Cplx BPT::getS
(
    const Voltage& Ube,
    Dbl		   t
) const 
{
    return(Ics/getUt(t)*exp(abs(Ube/getUt(t)))); 
}



// get steilheit
Cplx BPT::getS
(
    const Current& Ic, 
    Dbl		   t
) const 
{
    return (Ic/getUt(t)); 
}



// return output current depending on input voltage
Current BPT::getIout
(
    const Voltage& Uin, 
    Dbl		   t
) const
{
    if (Uin < Voltage(0)) return 0;
    return (Ics * exp(abs(Uin/getUt(t)))); 
} 



// get Ut at specified temperature
Voltage BPT::getUt(Dbl t)
{
//    return (PhysConst_BOLTZMANN / PhysConst_EPS0) * t; 
    return (PhysConst::Boltzmann / PhysConst::eps0) * t; 
}


END_NAMESPACE

